#include <iostream>
#include <list>

using namespace std;


typedef struct way
{
	int state;
	int* func;
	int alpha;
} Tway;

class CAutomaton
{
private:
	int m_size;
	int m_alphbt;
	int m_init;
	list<int> m_end;
	list<int*> m_func;
	void Release();
		
	void AddWays(int state, list<Tway*>& to, int max_state);

public:
	CAutomaton(void);
	CAutomaton(const CAutomaton& from);
	~CAutomaton(void);		
	
	friend ostream& operator <<(ostream& out, const CAutomaton& a);
	friend istream& operator >>(istream& in, CAutomaton& a);
	
	void Dualize(CAutomaton& dual);
	void Copy(const CAutomaton& from);

};
