
/*
 * Muj algoritmus funguje tak, ze nalezne vsechny spoje,
 * ktere jsou na ceste ke koncovych stavu. Tyto spoje rozdeli na dva,
 * z nich vsechny cesty z druheho stavu mimo te puvodni jdou do pekla.
 * Napr. 1-a->2 ... 1-a->3-a->2, 3-b->P
 * Hlavni fce algoritmu je CAutomaton::Dualize
 *
 * kompilace: g++ -o ag05 *
 */

#include <iostream>
#include "CAutomaton.h"

using namespace std;

int main() {
	CAutomaton a;
	cin >> a;
	CAutomaton b;
	a.Dualize(b);
	cout << b << endl;
	return 0;
}
